package org.androidtransfuse.util.matcher;

import com.google.common.collect.ImmutableSet;
import org.androidtransfuse.analysis.adapter.ASTType;

import java.lang.annotation.Annotation;

/**
 * @author John Ericksen
 */
public class ASTTypeMatcherBuilder {

    private final ImmutableSet.Builder<Class<? extends Annotation>> annotations = ImmutableSet.builder();

    public ASTTypeMatcherBuilder annotatedWith(Class<? extends Annotation> annotationClass) {
        annotations.add(annotationClass);
        return this;
    }

    public Matcher<ASTType> build() {
        return new ASTTypeMatcher(annotations.build());
    }
}
